config/routes.rb
Brimir::Application.routes.draw do

  devise_for :users

  resources :users

  resources :tickets, only: [:index, :show, :update, :new, :create]

  resources :replies, only: [:create, :new]
  get '/attachments/:id/:format' => 'attachments#show'

  root :to => 'tickets#index'

end

app/models/user.rb
# Brimir is a helpdesk system to handle email support requests.
# Copyright (C) 2012-2014 Ivaldi http://ivaldi.nl
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

class User < ActiveRecord::Base
  devise :database_authenticatable, :recoverable, :rememberable, :trackable, :validatable

  has_many :tickets
  has_many :replies

  scope :agents, -> {
    where(agent: true)
  }

  scope :ordered, -> {
    order(:email)
  }

  scope :by_email, ->(email) {
    where('LOWER(email) LIKE ?', '%' + email.downcase + '%')
  }

  scope :agents_and_subagents, ->(to) {
    where('incoming_address IS NULL OR incoming_address = ?', to)
  }

end

app/controllers/users_controller.rb
# Brimir is a helpdesk system to handle email support requests.
# Copyright (C) 2012-2014 Ivaldi http://ivaldi.nl
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

class UsersController < ApplicationController

  load_and_authorize_resource :user

  def edit
    @user = User.find(params[:id])
  end

  def update
    @user = User.find(params[:id])

    # if no password was posted, remove from params
    if params[:user][:password] == ''
      params[:user].delete(:password)
      params[:user].delete(:password_confirmation)
    end

    if @user.update_attributes(user_params)

      if current_user.agent?
        redirect_to users_url, notice: I18n::translate(:settings_saved)
      else
        redirect_to tickets_url, notice: I18n::translate(:settings_saved)
      end

    else
      render action: 'edit'
    end
  end

  def index

    if params[:format].nil?
      @users = User.ordered.page(params[:page])
    elsif params[:format] == 'json'
      if params[:init].present?
        @users = params[:q].split(',')
        @users = @users.map { |user| { id: user, text: user } }
      else
        @users = User.by_email(params[:q])
        @users = @users.map { |user| { id: user.email, text: user.email } }
      end

      render json: { users: @users }
    end

  end

  def new
    @user = User.new
  end

  def create
    @user = User.new(user_params)

    if @user.save
      redirect_to users_url, notice: I18n::translate(:user_added)
    else
      render 'new'
    end

  end

  private
    def user_params
      attributes = params.require(:user).permit(
          :email,
          :password,
          :password_confirmation,
          :remember_me,
          :signature,
          :agent,
          :notify,
      )

      # prevent normal user from changing email and role
      unless current_user.agent?
        attributes.delete(:email)
        attributes.delete(:agent)
      end

      return attributes
    end

end

app/views/users/_form.html.erb
<%= form_for @user, html: { class: 'edit_user' } do |f| %>
  <div class="row">

    <div class="large-6 columns">

      <h5><%= t(:account_settings) %></h5>
      <p><%= t(:only_fill_in_passwords_when_modifying) %></p>

      <% if can? :manage, User %>
        <%= f.text_field :email %>
      <% end %>

      <%= f.password_field :password %>

      <%= f.password_field :password_confirmation %>

      <% if can? :manage, User %>
        <%= f.check_box :agent, label: t(:user_is_an_agent) %>
      <% end %>
    </div>

    <% if @user.agent? || @user.new_record? %>
      <div class="large-6 columns">
        <h5><%= t(:email_settings) %></h5>

        <%= f.check_box :notify, label: t(:receive_new_ticket_notifications) %>

        <%= f.text_area :signature, rows: 5, cols: 20, class: 'tinymce' %>
      </div>
    <% end %>

  </div>
  <div class="row">
    <div class="large-12 columns">
  <hr />
      <%= f.submit t(:save), class: 'button radius' %>
    </div>
  </div>

<% end %>

app/views/users/edit.html.erb
<div class="row">
  <div class="large-6 columns">
    <h3><%= t(:edit_user) %></h3>
  </div>
</div>
<%= render 'form' %>

app/views/users/index.html.erb
<div class="row">
  <div class="large-12 columns">

    <h2 class="filter-title">Users</h2>
    <%= link_to t(:new_user), new_user_path, class: 'button right radius' %>

    <table class="full">
      <thead>
        <tr>
          <th><%= t(:email) %></th>
          <th><%= t(:role) %></th>
        </tr>
      </thead>
      <tbody>
        <% @users.each do |user| %>
          <tr>
            <td><%= link_to user.email, edit_user_path(user) %></td>
            <td><%= (user.agent?) ? t(:agent) : t(:customer) %></td>
          </tr>
        <% end %>
      </tbody>
    </table>

    <div class="pagination-centered">
      <%= will_paginate @users %>
    </div>
  </div>
</div>

app/views/users/new.html.erb
<div class="row">
  <div class="large-6 columns">
    <h3><%= t(:new_user) %></h3>
  </div>
</div>
<%= render 'form' %>